#define WINVER 0x500	// COLOR_GRAD...
#define _WIN32_WINDOWS 0x500	// WM_MOUSEWHEEL

// Inputbox with ScrollBar
// Button
// DialogText

#include <windows.h>
#include "resource.h"
#include "main.h"

#define DOUBLEBUFFER

HWND hMainWnd;

DWORD bordersize = 2;
DWORD titlesize = 18;
DWORD menusize = 18;
DWORD scrollbarsize = 16;

enum
{
	CM_NOAFFECT,
	CM_BORDER,
	CM_TITLE,
	CM_MENU,
	CM_SCROLLBAR,
};
DWORD currentmode = CM_NOAFFECT;

// Point in rect?
BOOL IsPointInRect(LPPOINT pt, LPRECT rc)
{
	if(rc->left <= pt->x && pt->x <= rc->right &&
		rc->top <= pt->y && pt->y <= rc->bottom)
		return TRUE;
	return FALSE;
}

DWORD hittest(LPPOINT mp)
{
	int i;
	int hit = WNDHT_NONE, subhit = WNDHT_NONE;
	int hitwnd = 0;

	for(i = 0; i < MAXWNDS; i++)
	{
		RECT wrc = {wnd[i].pos.x, wnd[i].pos.y, wnd[i].pos.x + wnd[i].size.cx, wnd[i].pos.y + wnd[i].size.cy};
		RECT rc;

		/*** BorderCheck ***/
		rc.top = wrc.bottom - 2 - bordersize - titlesize;
		rc.bottom = wrc.bottom;
		rc.left = wrc.left;
		rc.right = wrc.left + 2 + bordersize + titlesize;
		if(IsPointInRect(mp, &rc))
		{
			hitwnd = i;
			hit = WNDHT_BOTTOMLEFT;
		}
		rc.left = wrc.right - 2 - bordersize - titlesize;
		rc.right = wrc.right;
		if(IsPointInRect(mp, &rc))
		{
			hitwnd = i;
			hit = WNDHT_BOTTOMRIGHT;
		}
		rc.top = wrc.bottom - 2 - bordersize;
		rc.left = wrc.left + 2 + bordersize + titlesize + 1;
		rc.right = wrc.right - 2 - bordersize - titlesize - 1;
		if(IsPointInRect(mp, &rc))
		{
			hitwnd = i;
			hit = WNDHT_BOTTOM;
		}

		rc.top = wrc.top + 2 + bordersize + titlesize + 1;
		rc.bottom = wrc.bottom - 2 - bordersize - titlesize - 1;
		rc.left = wrc.left;
		rc.right = wrc.left + 2 + bordersize;
		if(IsPointInRect(mp, &rc))
		{
			hitwnd = i;
			hit = WNDHT_LEFT;
		}
		rc.left = wrc.right - 2 - bordersize;
		rc.right = wrc.right;
		if(IsPointInRect(mp, &rc))
		{
			hitwnd = i;
			hit = WNDHT_RIGHT;
		}

		rc.top = wrc.top;
		rc.bottom = wrc.top + 2 + bordersize + titlesize;
		rc.left = wrc.left;
		rc.right = wrc.left + 2 + bordersize + titlesize;
		if(IsPointInRect(mp, &rc))
		{
			hitwnd = i;
			hit = WNDHT_TOPLEFT;
		}
		rc.left = wrc.right - 2 - bordersize - titlesize;
		rc.right = wrc.right;
		if(IsPointInRect(mp, &rc))
		{
			hitwnd = i;
			hit = WNDHT_TOPRIGHT;
		}
		rc.bottom = wrc.top + 2 + bordersize;
		rc.left = wrc.left + 2 + bordersize + titlesize + 1;
		rc.right = wrc.right - 2 - bordersize - titlesize - 1;
		if(IsPointInRect(mp, &rc))
		{
			hitwnd = i;
			hit = WNDHT_TOP;
		}
		/*** Border End ***/

		// Resize to Title+Client
		if(wnd[i].type == WINDOW_NORMAL)
		{
			wrc.left += 2 + bordersize + 1;
			wrc.top += 2 + bordersize + 1;
			wrc.right -= 2 + bordersize + 1;
			wrc.bottom -= 2 + bordersize + 1;
		}
		if(wnd[i].type == WINDOW_DIALOG)
		{
			wrc.left += 2 + 1;
			wrc.top += 2 + 1;
			wrc.right -= 2 + 1;
			wrc.bottom -= 2 + 1;
		}

		rc.left = wrc.left;
		rc.top = wrc.top;
		rc.right = wrc.right - 1;
		rc.bottom = wrc.bottom - 1;
		if(IsPointInRect(mp, &rc))
		{
			hitwnd = i;
			hit = WNDHT_CLIENT;
		}

		if(wnd[i].type == WINDOW_NORMAL || wnd[i].type == WINDOW_DIALOG)
		{
			rc.left = wrc.left;
			rc.right = wrc.right - 1;
			rc.top = wrc.top;
			rc.bottom = wrc.top + titlesize - 1;
			if(IsPointInRect(mp, &rc))
			{
				hitwnd = i;
				hit = WNDHT_TITLE;
			}
		}

		if(wnd[i].type == WINDOW_NORMAL || wnd[i].type == WINDOW_DIALOG)
		{
			rc.top = wrc.top;
			rc.bottom = wrc.top + titlesize - 1;
			rc.left = wrc.right - 2 - (titlesize - 2) - 1;
			rc.right = wrc.right - 1;
			if(IsPointInRect(mp, &rc))
			{
				hitwnd = i;
				hit = WNDHT_BTNCLOSE;
			}

			if(wnd[i].type == WINDOW_NORMAL)
			{
				rc.left = wrc.right - 2 - (titlesize - 2) * 2 - 2;
				rc.right = wrc.right - 2 - (titlesize - 2) - 2;
				if(IsPointInRect(mp, &rc))
				{
					hitwnd = i;
					hit = WNDHT_BTNMAXIMIZE;
				}
				rc.left = wrc.right - 2 - (titlesize - 2) * 3 - 2;
				rc.right = wrc.right - 2 - (titlesize - 2) * 2 - 2 - 1;
				if(IsPointInRect(mp, &rc))
				{
					hitwnd = i;
					hit = WNDHT_BTNMINIMIZE;
				}
			}

			wrc.top += titlesize + 1;
			// Now wrc is client size

			if(wnd[i].style & WINDOW_MENU)
			{
				rc.left = wrc.left;
				rc.right = wrc.right;
				rc.top = wrc.top;
				rc.bottom = wrc.top + menusize - 1;
				if(IsPointInRect(mp, &rc))
				{
					char* p;
					SIZE s;
					int posx = wrc.left;
					int j;
					HDC hdc = GetDC(hMainWnd);

					hitwnd = i;
					hit = WNDHT_MENU;

					// MenuCheck
					for(p = wnd[i].menu, j = 0; *p; p = strchar(p, '\0') + 1, j++)
					{
						GetTextExtentPoint32(hdc, p, strlength(p), &s);
						rc.left = posx;
						rc.right = posx + s.cx + 16;
						if(IsPointInRect(mp, &rc))
						{
							if(wnd[i].style & WINDOW_ACTIVE)
							{
								if(j == 0)
									hit = WNDHT_MENU;
								if(j == 1)
									hit = WNDHT_MENUHILIGHT;
								if(j >= 2)
									hit = WNDHT_MENUDISABLE;
							}else
								hit = WNDHT_MENUINACTIVE;
							break;
						}

						posx += s.cx + 16;
					}
					ReleaseDC(hMainWnd, hdc);
				}
			}
		}
		if(wnd[i].type == WINDOW_TOOLTIP || wnd[i].type == WINDOW_POPUPMENU)
		{
			rc.left = wrc.left;
			rc.top = wrc.top;
			rc.right = wrc.right;
			rc.bottom = wrc.bottom;
			if(IsPointInRect(mp, &rc))
			{
				hitwnd = i;
				hit = WNDHT_TITLE;

				if(wnd[i].type == WINDOW_POPUPMENU)
				{
					char* p;
					int posy = wrc.top;
					SIZE s;
					int j;
					HDC hdc = GetDC(hMainWnd);

					for(p = wnd[i].menu, j = 0; *p; p = strchar(p, '\0') + 1, j++)
					{
						if(*p == '-')
							s.cy = 8;
						else
							GetTextExtentPoint32(hdc, p, strlength(p), &s);
						rc.top = posy;
						rc.bottom = posy + s.cy;
						if(IsPointInRect(mp, &rc))
						{
							if(*p == '-')
								subhit = WNDHT_MENUSEPARATOR;
							else
							{
								if(j == 0)
									subhit = WNDHT_MENU;
								if(j == 1)
									subhit = WNDHT_MENUHILIGHT;
								if(j >= 2)
									subhit = WNDHT_MENUDISABLE;
							}
							break;
						}

						posy += s.cy;
					}

					ReleaseDC(hMainWnd, hdc);
				}
			}
		}
	}

	return MAKELONG(MAKEWORD(hit, subhit), hitwnd);	// hitwnd << 16 + hit
}

void line(HDC hdc, int sx, int sy, int ex, int ey)
{
	POINT old;

	MoveToEx(hdc, sx, sy, &old);
	LineTo(hdc, ex, ey);
	MoveToEx(hdc, old.x, old.y, NULL);

	return;
}

HBRUSH SelectSolidBrush(HDC hdc, COLORREF crColor)
{
	HBRUSH newbrush, oldbrush;

	newbrush = CreateSolidBrush(crColor);
	oldbrush = SelectObject(hdc, newbrush);

	return oldbrush;
}
HPEN SelectPen(HDC hdc, int fnPenStyle, int nWidth, COLORREF crColor)
{
	HPEN newpen, oldpen;

	newpen = CreatePen(fnPenStyle, nWidth, crColor);
	oldpen = SelectObject(hdc, newpen);

	return oldpen;
}
HBITMAP SelectDIBSection(
    HDC hdc,
    CONST BITMAPINFO *pbmi,
    UINT iUsage,
    VOID *ppvBits,
    HANDLE hSection,
    DWORD dwOffset
)
{
	HBITMAP newbmp, oldbmp;

	newbmp = CreateDIBSection(hdc, pbmi, iUsage, ppvBits, hSection, dwOffset);
	oldbmp = SelectObject(hdc, newbmp);

	return oldbmp;
}
HFONT SelectFont(HDC hdc, LPCSTR fontname, int size, int style)
{
	HFONT newfont, oldfont;
	LOGFONT lf = {0};

	lf.lfCharSet = DEFAULT_CHARSET;
	lf.lfHeight = size;
	if(style & 1)
		lf.lfWeight = FW_BOLD;
	strcopy(lf.lfFaceName, fontname);
	newfont = CreateFontIndirect(&lf);
	oldfont = SelectObject(hdc, newfont);

	return oldfont;
}

BOOL RestoreObject(HDC hdc, HGDIOBJ oldobj)
{
	return DeleteObject(SelectObject(hdc, oldobj));
}

int FillRectangle(HDC hdc, int sx, int sy, int ex, int ey)
{
	RECT rc;

	rc.left = sx;
	rc.top = sy;
	rc.right = ex;
	rc.bottom = ey;

	return FillRect(hdc, &rc, GetCurrentObject(hdc, OBJ_BRUSH));
}

void drawBox(HDC hdc, int sx, int sy, int ex, int ey, int flip)	// flip: 0=normal 1=windowbox 2=sink
{
	HPEN oldpen;
	HBRUSH oldbrs;

	ex--;
	ey--;

	// DrawBorder
	switch(flip)
	{
	case 0:
		oldpen = SelectPen(hdc, PS_SOLID, 1, syscolor.ButtonHilight);
		break;
	case 1:
		oldpen = SelectPen(hdc, PS_SOLID, 1, syscolor.ButtonLight);
		break;
	case 2:
		oldpen = SelectPen(hdc, PS_SOLID, 1, syscolor.ButtonShadow);
		break;
	}
	line(hdc, sx, sy, ex, sy);
	line(hdc, sx, sy, sx, ey);
	RestoreObject(hdc, oldpen);
	switch(flip)
	{
	case 0:
		oldpen = SelectPen(hdc, PS_SOLID, 1, syscolor.ButtonLight);
		break;
	case 1:
		oldpen = SelectPen(hdc, PS_SOLID, 1, syscolor.ButtonHilight);
		break;
	case 2:
		oldpen = SelectPen(hdc, PS_SOLID, 1, syscolor.ButtonDkShadow);
		break;
	}
	line(hdc, sx + 1, sy + 1, ex - 1, sy + 1);
	line(hdc, sx + 1, sy + 1, sx + 1, ey - 1);
	RestoreObject(hdc, oldpen);
	switch(flip)
	{
	case 0:
	case 1:
		oldpen = SelectPen(hdc, PS_SOLID, 1, syscolor.ButtonShadow);
		break;
	case 2:
		oldpen = SelectPen(hdc, PS_SOLID, 1, syscolor.ButtonLight);
		break;
	}
	line(hdc, sx + 1, ey - 1, ex - 1, ey - 1);
	line(hdc, ex - 1, sy + 1, ex - 1, ey);
	RestoreObject(hdc, oldpen);
	switch(flip)
	{
	case 0:
	case 1:
		oldpen = SelectPen(hdc, PS_SOLID, 1, syscolor.ButtonDkShadow);
		break;
	case 2:
		oldpen = SelectPen(hdc, PS_SOLID, 1, syscolor.ButtonHilight);
		break;
	}
	line(hdc, sx, ey, ex, ey);
	line(hdc, ex, sy, ex, ey + 1);
	RestoreObject(hdc, oldpen);

	// FillBox
	oldpen = SelectObject(hdc, GetStockObject(NULL_PEN));
	oldbrs = SelectSolidBrush(hdc, syscolor.ButtonFace);
	Rectangle(hdc, sx + 2, sy + 2, ex, ey);
	RestoreObject(hdc, oldbrs);
	SelectObject(hdc, oldpen);

	return;
}

void drawWindow(HDC hdc, WINDOW* wnd)
{
	HPEN oldpen;
	HBRUSH oldbrs;
	COLORREF oldclr;
	RECT wrc = {wnd->pos.x, wnd->pos.y, wnd->pos.x + wnd->size.cx, wnd->pos.y + wnd->size.cy};
	HFONT oldfont = SelectFont(hdc, "MS Sans Serif", 11, 0);

	SetBkMode(hdc, TRANSPARENT);

	switch(wnd->type)
	{
	case WINDOW_NORMAL:
	case WINDOW_DIALOG:
		// DrawWnd
		drawBox(hdc, wrc.left, wrc.top, wrc.right, wrc.bottom, 1);

		if(wnd->type == WINDOW_NORMAL)
		{
			// DrawBorder(by fill)
			if(wnd->style & WINDOW_ACTIVE)
				oldbrs = SelectSolidBrush(hdc, syscolor.ActiveBorder);
			else
				oldbrs = SelectSolidBrush(hdc, syscolor.InactiveBorder);
			FillRectangle(hdc, wrc.left + 2, wrc.top + 2, wrc.right - 2, wrc.bottom - 2);
			RestoreObject(hdc, oldbrs);

			wrc.left += 2 + bordersize + 1;
			wrc.top += 2 + bordersize + 1;
			wrc.right -= 2 + bordersize + 1;
			wrc.bottom -= 2 + bordersize + 1;
		}else
		{
			wrc.left += 2 + 1;
			wrc.top += 2 + 1;
			wrc.right -= 2 + 1;
			wrc.bottom -= 2 + 1;
		}
		// Now, wrc is title+client area.

		// DrawInner
		oldbrs = SelectSolidBrush(hdc, syscolor.ButtonFace);
		FillRectangle(hdc, wrc.left - 1, wrc.top - 1, wrc.right + 1, wrc.bottom + 1);
		RestoreObject(hdc, oldbrs);

		// DrawGradientTitleBar
		{
			struct COLORREFSTRUCT
			{
				BYTE r;
				BYTE g;
				BYTE b;
				BYTE resv;
			}lc, rc, cc;
			int x, maxx;

			if(wnd->style & WINDOW_ACTIVE)
			{
				lc = *(struct COLORREFSTRUCT*)&syscolor.ActiveTitle;
				rc = *(struct COLORREFSTRUCT*)&syscolor.GradientActiveTitle;
			}else
			{
				lc = *(struct COLORREFSTRUCT*)&syscolor.InactiveTitle;
				rc = *(struct COLORREFSTRUCT*)&syscolor.GradientInactiveTitle;
			}

			// Left IconBkgnd
			oldbrs = SelectSolidBrush(hdc, *(COLORREF*)&lc);
			FillRectangle(hdc, wrc.left, wrc.top, wrc.left + titlesize, wrc.top + titlesize);
			RestoreObject(hdc, oldbrs);

			if(wnd->type == WINDOW_NORMAL)
				maxx = (wrc.right - titlesize * 3) - (wrc.left + titlesize);
			else
				maxx = (wrc.right - titlesize) - (wrc.left + titlesize);

			for(x = 0; x < maxx; x++)
			{
				cc.r = (BYTE)(lc.r + /*FinalDelta*/(rc.r - lc.r) * /*0~1*/x / maxx);
				cc.g = (BYTE)(lc.g + /*FinalDelta*/(rc.g - lc.g) * /*0~1*/x / maxx);
				cc.b = (BYTE)(lc.b + /*FinalDelta*/(rc.b - lc.b) * /*0~1*/x / maxx);
				oldpen = SelectPen(hdc, PS_SOLID, 1, *(COLORREF*)&cc);
				line(hdc, wrc.left + titlesize + x, wrc.top, wrc.left + titlesize + x, wrc.top + titlesize);
				RestoreObject(hdc, oldpen);
			}

			// Right ButtonsBkgnd
			oldbrs = SelectSolidBrush(hdc, *(COLORREF*)&rc);
			if(wnd->type == WINDOW_NORMAL)
				FillRectangle(hdc, wrc.right - titlesize * 3, wrc.top, wrc.right, wrc.top + titlesize);
			else
				FillRectangle(hdc, wrc.right - titlesize, wrc.top, wrc.right, wrc.top + titlesize);
			RestoreObject(hdc, oldbrs);
		}

		// DrawTitleIcon
		if(wnd->type == WINDOW_NORMAL)
		{
			HICON hi = LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_MAINICON), IMAGE_ICON, titlesize - 2, titlesize - 2, LR_DEFAULTCOLOR);
			DrawIconEx(hdc, wrc.left + 1, wrc.top + 1, hi, titlesize - 2, titlesize - 2, 0, NULL, DI_NORMAL);
			DestroyIcon(hi);
		}
		// DrawTitleText
		if(wnd->style & WINDOW_ACTIVE)
			oldclr = SetTextColor(hdc, syscolor.TitleText);
		else
			oldclr = SetTextColor(hdc, syscolor.InactiveTitleText);
		{
			HFONT oldfont = SelectFont(hdc, "MS Sans Serif", 11, 1);
			TextOut(hdc, wrc.left + 1 + 1 + ((wnd->type != WINDOW_DIALOG) ? titlesize : 0), wrc.top + 1, wnd->title, strlength(wnd->title));
			RestoreObject(hdc, oldfont);
		}
		SetTextColor(hdc, oldclr);

		// Draw3Buttons
		{
			HFONT oldfont = SelectFont(hdc, "Marlett", titlesize - 8, 0);
			COLORREF oc;

			drawBox(hdc, wrc.right - 2 - (titlesize - 2), wrc.top + 2, wrc.right - 2, wrc.top + 2 + (titlesize - 4), 0);
			oc = SetTextColor(hdc, syscolor.ButtonText);
			TextOut(hdc, wrc.right - 2 - titlesize + 2 + 3, wrc.top + 2 + 2, "r", 1);
			if(wnd->type == WINDOW_NORMAL)
			{
				drawBox(hdc, wrc.right - 2 - (titlesize - 2) * 2 - 2, wrc.top + 2, wrc.right - 2 - (titlesize - 2) - 2, wrc.top + 2 + (titlesize - 4), 0);
				if(wnd->style & WINDOW_NOMAXIMIZE)
				{
					COLORREF oc;

					oc = SetTextColor(hdc, syscolor.ButtonHilight);
					TextOut(hdc, wrc.right - 2 - (titlesize - 2) * 2 - 2 + 3 + 1, wrc.top + 2 + 2 + 1, "1", 1);
					SetTextColor(hdc, syscolor.ButtonShadow);
					TextOut(hdc, wrc.right - 2 - (titlesize - 2) * 2 - 2 + 3, wrc.top + 2 + 2, "1", 1);
					SetTextColor(hdc, oc);
				}else
				{
					TextOut(hdc, wrc.right - 2 - (titlesize - 2) * 2 - 2 + 3, wrc.top + 2 + 2, "1", 1);
				}

				drawBox(hdc, wrc.right - 2 - (titlesize - 2) * 3 - 2, wrc.top + 2, wrc.right - 2 - (titlesize - 2) * 2 - 2, wrc.top + 2 + (titlesize - 4), 0);
				TextOut(hdc, wrc.right - 2 - (titlesize - 2) * 3 - 2 + 3, wrc.top + 2 + 2, "0", 1);
			}
			RestoreObject(hdc, oldfont);
			SetTextColor(hdc, oc);
		}

		wrc.top += titlesize + 1;
		// Now, wrc is client area.

		// DrawMenu
		if(wnd->style & WINDOW_MENU)
		{
			char* p;
			SIZE s;
			int posx = wrc.left;
			int i;

			oldbrs = SelectSolidBrush(hdc, syscolor.Menu);
			FillRectangle(hdc, wrc.left, wrc.top, wrc.right, wrc.top + menusize);
			RestoreObject(hdc, oldbrs);

			for(p = wnd->menu, i = 0; *p; p = strchar(p, '\0') + 1, i++)
			{
				GetTextExtentPoint32(hdc, p, strlength(p), &s);

				// Fill active menu item
				if(wnd->style & WINDOW_ACTIVE && i == 1)
				{
					oldbrs = SelectSolidBrush(hdc, syscolor.Hilight);
					FillRectangle(hdc, posx, wrc.top, posx + s.cx + 16, wrc.top + menusize);
					RestoreObject(hdc, oldbrs);
				}

				if(wnd->style & WINDOW_ACTIVE)
				{
					if(i == 0)
						oldclr = SetTextColor(hdc, syscolor.MenuText);
					if(i == 1)
						oldclr = SetTextColor(hdc, syscolor.HilightText);
					if(i >= 2)
					{
						oldclr = SetTextColor(hdc, syscolor.ButtonHilight);
						TextOut(hdc, posx + 8 + 1, wrc.top + 1, p, strlength(p));
						SetTextColor(hdc, oldclr);
						oldclr = SetTextColor(hdc, syscolor.ButtonShadow);
					}
				}else
					oldclr = SetTextColor(hdc, syscolor.ButtonShadow);
				TextOut(hdc, posx + 8, wrc.top, p, strlength(p));

				SetTextColor(hdc, oldclr);
				posx += s.cx + 16;
			}
			wrc.top += menusize + 1;
			// Now, wrc is REALLY client size.
		}

		// DrawClient
		if(wnd->type == WINDOW_NORMAL)
		{	// draw input box
			drawBox(hdc, wrc.left, wrc.top, wrc.right, wrc.bottom, 2);
			if(wnd->style & WINDOW_ACTIVE)
			{
				// ActiveWindow: EditControl

				// Fill input box
				oldbrs = SelectSolidBrush(hdc, syscolor.Window);
				FillRectangle(hdc, wrc.left + 2, wrc.top + 2, wrc.right - 2, wrc.bottom - 2);
				RestoreObject(hdc, oldbrs);

				// draw scroll bar
				{
					HFONT oldfont = SelectFont(hdc, "Marlett", scrollbarsize - 4, 0);
					COLORREF oc;

					oc = SetTextColor(hdc, syscolor.ButtonText);

					drawBox(hdc, wrc.right - 2 - scrollbarsize, wrc.top + 2, wrc.right - 2, wrc.top + 2 + scrollbarsize, 1);
					TextOut(hdc, wrc.right - 2 - scrollbarsize + 2, wrc.top + 2 + 2, "t", 1);
					oldbrs = SelectSolidBrush(hdc, syscolor.Scrollbar);
					FillRectangle(hdc, wrc.right - 2 - scrollbarsize, wrc.top + 2 + scrollbarsize, wrc.right - 2, wrc.bottom - 2 - scrollbarsize);
					RestoreObject(hdc, oldbrs);
					drawBox(hdc, wrc.right - 2 - scrollbarsize, wrc.bottom - 2 - scrollbarsize, wrc.right - 2, wrc.bottom - 2, 1);
					TextOut(hdc, wrc.right - 2 - scrollbarsize + 2, wrc.bottom - 2 - scrollbarsize + 2, "u", 1);

					SetTextColor(hdc, oc);
					RestoreObject(hdc, oldfont);

					oc = SetTextColor(hdc, syscolor.WindowText);
					TextOut(hdc, wrc.left + 2, wrc.top + 2, "Window Text", 11);
					SetTextColor(hdc, oc);
				}
			}else
			{
				// InactiveWindow: AppWorkSpace
				oldbrs = SelectSolidBrush(hdc, syscolor.AppWorkSpace);
				FillRectangle(hdc, wrc.left + 2, wrc.top + 2, wrc.right - 2, wrc.bottom - 2);
				RestoreObject(hdc, oldbrs);
			}
		}
		if(wnd->type == WINDOW_DIALOG)
		{	// draw string/button
			COLORREF oc;
			SIZE s;

			oc = SetTextColor(hdc, syscolor.WindowText);
			TextOut(hdc, wrc.left + 2, wrc.top + 2, "DialogBox Text", 14);
			SetTextColor(hdc, oc);

			oldbrs = SelectSolidBrush(hdc, syscolor.WindowFrame);
			FillRectangle(hdc, (wrc.right + wrc.left) / 2 - 60 - 1, wrc.bottom - 35 - 1, (wrc.right + wrc.left) / 2 - 10 + 1, wrc.bottom - 5 + 1);
			RestoreObject(hdc, oldbrs);
			drawBox(hdc, (wrc.right + wrc.left) / 2 - 60, wrc.bottom - 35, (wrc.right + wrc.left) / 2 - 10, wrc.bottom - 5, 0);
			drawBox(hdc, (wrc.right + wrc.left) / 2 + 10, wrc.bottom - 35, (wrc.right + wrc.left) / 2 + 60, wrc.bottom - 5, 0);

			oc = SetTextColor(hdc, syscolor.ButtonText);
			GetTextExtentPoint32(hdc, "OK", 2, &s);
			TextOut(hdc, (wrc.right + wrc.left) / 2 - 60 + (50 - s.cx) / 2, wrc.bottom - 35 + (30 - s.cy) / 2, "OK", 2);
			GetTextExtentPoint32(hdc, "Cancel", 6, &s);
			TextOut(hdc, (wrc.right + wrc.left) / 2 + 10 + (50 - s.cx) / 2, wrc.bottom - 35 + (30 - s.cy) / 2, "Cancel", 6);
			SetTextColor(hdc, oc);
		}

		break;
	case WINDOW_TOOLTIP:
		oldpen = SelectPen(hdc, PS_SOLID, 1, syscolor.WindowFrame);
		oldbrs = SelectSolidBrush(hdc, syscolor.InfoWindow);
		oldclr = SetTextColor(hdc, syscolor.InfoText);

		Rectangle(hdc, wrc.left, wrc.top, wrc.right, wrc.bottom);
		TextOut(hdc, wrc.left + 1, wrc.top + 1, wnd->title, strlength(wnd->title));

		RestoreObject(hdc, oldpen);
		RestoreObject(hdc, oldbrs);
		SetTextColor(hdc, oldclr);
		break;
	case WINDOW_POPUPMENU:
		{
			char* p;
			int i;
			int posy = 0;

			for(p = wnd->menu, i = 0; *p; p = strchar(p, '\0') + 1, i++)
			{
				if(*p == '-')
					posy += 8;
				else
				{
					SIZE s;

					GetTextExtentPoint32(hdc, p, strlength(p), &s);

					posy += s.cy;
				}
			}
			wnd->size.cy = posy + 6;

			wrc.bottom = wnd->pos.y + wnd->size.cy;
		}

		drawBox(hdc, wrc.left, wrc.top, wrc.right, wrc.bottom, 1);

		wrc.left += 2;
		wrc.top += 2;
		wrc.right -= 2;
		wrc.bottom -= 2;
		{
			char* p;
			SIZE s;
			int posy = wrc.top;
			int i;

			oldbrs = SelectSolidBrush(hdc, syscolor.ButtonFace);
			FillRectangle(hdc, wrc.left, wrc.top, wrc.right, wrc.bottom);
			RestoreObject(hdc, oldbrs);

			wrc.left++;
			wrc.top++;
			wrc.right--;
			wrc.bottom--;

			oldbrs = SelectSolidBrush(hdc, syscolor.Menu);
			FillRectangle(hdc, wrc.left, wrc.top, wrc.right, wrc.bottom);
			RestoreObject(hdc, oldbrs);

			for(p = wnd->menu, i = 0; *p; p = strchar(p, '\0') + 1, i++)
			{
				if(*p == '-')
				{
					posy += 3;
					oldpen = SelectPen(hdc, PS_SOLID, 1, syscolor.ButtonHilight);
					line(hdc, wrc.left + 1, posy + 1, wrc.right - 1, posy + 1);
					RestoreObject(hdc, oldpen);
					oldpen = SelectPen(hdc, PS_SOLID, 1, syscolor.ButtonShadow);
					line(hdc, wrc.left + 1, posy, wrc.right - 1, posy);
					RestoreObject(hdc, oldpen);
					posy += 5;
				}else
				{
					GetTextExtentPoint32(hdc, p, strlength(p), &s);

					// Fill active menu item
					if(i == 1)
					{
						oldbrs = SelectSolidBrush(hdc, syscolor.Hilight);
						FillRectangle(hdc, wrc.left, posy, wrc.right, posy + s.cy);
						RestoreObject(hdc, oldbrs);
					}

					if(i == 0)
						oldclr = SetTextColor(hdc, syscolor.MenuText);
					if(i == 1)
						oldclr = SetTextColor(hdc, syscolor.HilightText);
					if(i >= 2)
					{
						oldclr = SetTextColor(hdc, syscolor.ButtonHilight);
						TextOut(hdc, wrc.left + 1, posy + 1, p, strlength(p));
						SetTextColor(hdc, oldclr);
						oldclr = SetTextColor(hdc, syscolor.ButtonShadow);
					}
					TextOut(hdc, wrc.left, posy, p, strlength(p));

					SetTextColor(hdc, oldclr);
					posy += s.cy;
				}
			}
		}
		break;
	}

	RestoreObject(hdc, oldfont);

	return;
}

void GetReg(LPCSTR regkey, PHKEY hk, LPSTR str)
{
	char regk[32];

	strncopy(regk, regkey, strchar(regkey, '\\') - regkey);
	regk[strchar(regkey, '\\') - regkey] = '\0';

	*hk = 0;
	if(!strcomp(regk, "HKEY_CLASSES_ROOT") || !strcomp(regk, "HKCR"))
		*hk = HKEY_CLASSES_ROOT;
	if(!strcomp(regk, "HKEY_CURRENT_USER") || !strcomp(regk, "HKCU"))
		*hk = HKEY_CURRENT_USER;
	if(!strcomp(regk, "HKEY_LOCAL_MACHINE") || !strcomp(regk, "HKLM"))
		*hk = HKEY_LOCAL_MACHINE;
	if(!strcomp(regk, "HKEY_USERS") || !strcomp(regk, "HKU"))
		*hk = HKEY_USERS;

	strcopy(str, strchar(regkey, '\\') + 1);

	return;
}

COLORREF GetRegColor(HKEY hk, LPCSTR subkey)
{
	char col[80];
	char* p = col;
	LONG siz;
	COLORREF color = 0;
	int i;

	siz = sizeof(col);
	if(RegQueryValueEx(hk, subkey, NULL, NULL, col, &siz) != ERROR_SUCCESS)
		return 0;

	for(i = 0; i < 3; i++)
		color = color | getTokenDword(&p, ' ') << (i * 8);

	return color;
}

LONG SetRegColor(HKEY hk, LPCSTR subkey, COLORREF crColor)
{
	char col[80];

	wsprintf(col, "%d %d %d", crColor & 0xFF, crColor >> 8 & 0xFF, crColor >> 16 & 0xFF);

	return RegSetValueEx(hk, subkey, 0, REG_SZ, col, strlength(col));
}

void LoadColor(LPCSTR regkey)
{
	HKEY hk, hkey = 0;
	char str[256];

	GetReg(regkey, &hkey, str);

	if(RegOpenKeyEx(hkey, str, 0, KEY_QUERY_VALUE, &hk) != ERROR_SUCCESS)
		return;

	syscolor.ActiveBorder			= GetRegColor(hk, "ActiveBorder");
	syscolor.ActiveTitle			= GetRegColor(hk, "ActiveTitle");
	syscolor.AppWorkSpace			= GetRegColor(hk, "AppWorkSpace");
	syscolor.Background				= GetRegColor(hk, "Background");
	//syscolor.ButtonAlternateFace	= GetRegColor(hk, "ButtonAlternateFace");
	syscolor.ButtonDkShadow			= GetRegColor(hk, "ButtonDkShadow");
	syscolor.ButtonFace				= GetRegColor(hk, "ButtonFace");
	syscolor.ButtonHilight			= GetRegColor(hk, "ButtonHilight");
	syscolor.ButtonLight			= GetRegColor(hk, "ButtonLight");
	syscolor.ButtonShadow			= GetRegColor(hk, "ButtonShadow");
	syscolor.ButtonText				= GetRegColor(hk, "ButtonText");
	syscolor.GradientActiveTitle	= GetRegColor(hk, "GradientActiveTitle");
	syscolor.GradientInactiveTitle	= GetRegColor(hk, "GradientInactiveTitle");
	syscolor.GrayText				= GetRegColor(hk, "GrayText");
	syscolor.Hilight				= GetRegColor(hk, "Hilight");
	syscolor.HilightText			= GetRegColor(hk, "HilightText");
	syscolor.HotTrackingColor		= GetRegColor(hk, "HotTrackingColor");
	syscolor.InactiveBorder			= GetRegColor(hk, "InactiveBorder");
	syscolor.InactiveTitle			= GetRegColor(hk, "InactiveTitle");
	syscolor.InactiveTitleText		= GetRegColor(hk, "InactiveTitleText");
	syscolor.InfoText				= GetRegColor(hk, "InfoText");
	syscolor.InfoWindow				= GetRegColor(hk, "InfoWindow");
	syscolor.Menu					= GetRegColor(hk, "Menu");
	//syscolor.MenuBar				= GetRegColor(hk, "MenuBar");
	//syscolor.MenuHilight			= GetRegColor(hk, "MenuHilight");
	syscolor.MenuText				= GetRegColor(hk, "MenuText");
	syscolor.Scrollbar				= GetRegColor(hk, "Scrollbar");
	syscolor.TitleText				= GetRegColor(hk, "TitleText");
	syscolor.Window					= GetRegColor(hk, "Window");
	syscolor.WindowFrame			= GetRegColor(hk, "WindowFrame");
	syscolor.WindowText				= GetRegColor(hk, "WindowText");

	RegCloseKey(hk);

	return;
}

void SaveColor(LPCSTR regkey)
{
	HKEY hk, hkey = 0;
	char str[256];

	GetReg(regkey, &hkey, str);

	if(RegOpenKeyEx(hkey, str, 0, KEY_SET_VALUE, &hk) != ERROR_SUCCESS)
		return;

	SetRegColor(hk, "ActiveBorder",			syscolor.ActiveBorder);
	SetRegColor(hk, "ActiveTitle",			syscolor.ActiveTitle);
	SetRegColor(hk, "AppWorkSpace",			syscolor.AppWorkSpace);
	SetRegColor(hk, "Background",			syscolor.Background);
	//SetRegColor(hk, "ButtonAlternateFace",	syscolor.ButtonAlternateFace);
	SetRegColor(hk, "ButtonDkShadow",		syscolor.ButtonDkShadow);
	SetRegColor(hk, "ButtonFace",			syscolor.ButtonFace);
	SetRegColor(hk, "ButtonHilight",		syscolor.ButtonHilight);
	SetRegColor(hk, "ButtonLight",			syscolor.ButtonLight);
	SetRegColor(hk, "ButtonShadow",			syscolor.ButtonShadow);
	SetRegColor(hk, "ButtonText",			syscolor.ButtonText);
	SetRegColor(hk, "GradientActiveTitle",	syscolor.GradientActiveTitle);
	SetRegColor(hk, "GradientInactiveTitle",syscolor.GradientInactiveTitle);
	SetRegColor(hk, "GrayText",				syscolor.GrayText);
	SetRegColor(hk, "Hilight",				syscolor.Hilight);
	SetRegColor(hk, "HilightText",			syscolor.HilightText);
	SetRegColor(hk, "HotTrackingColor",		syscolor.HotTrackingColor);
	SetRegColor(hk, "InactiveBorder",		syscolor.InactiveBorder);
	SetRegColor(hk, "InactiveTitle",		syscolor.InactiveTitle);
	SetRegColor(hk, "InactiveTitleText",	syscolor.InactiveTitleText);
	SetRegColor(hk, "InfoText",				syscolor.InfoText);
	SetRegColor(hk, "InfoWindow",			syscolor.InfoWindow);
	SetRegColor(hk, "Menu",					syscolor.Menu);
	//SetRegColor(hk, "MenuBar",				syscolor.MenuBar);
	//SetRegColor(hk, "MenuHilight",			syscolor.MenuHilight);
	SetRegColor(hk, "MenuText",				syscolor.MenuText);
	SetRegColor(hk, "Scrollbar",			syscolor.Scrollbar);
	SetRegColor(hk, "TitleText",			syscolor.TitleText);
	SetRegColor(hk, "Window",				syscolor.Window);
	SetRegColor(hk, "WindowFrame",			syscolor.WindowFrame);
	SetRegColor(hk, "WindowText",			syscolor.WindowText);

	RegCloseKey(hk);

	return;
}

void LoadCurrentColor(void)
{
	syscolor.ActiveBorder			= GetSysColor(COLOR_ACTIVEBORDER);
	syscolor.ActiveTitle			= GetSysColor(COLOR_ACTIVECAPTION);
	syscolor.AppWorkSpace			= GetSysColor(COLOR_APPWORKSPACE);
	syscolor.Background				= GetSysColor(COLOR_BACKGROUND);
	//syscolor.ButtonAlternateFace	= GetSysColor(COLOR_3DFACE);
	syscolor.ButtonDkShadow			= GetSysColor(COLOR_3DDKSHADOW);
	syscolor.ButtonFace				= GetSysColor(COLOR_3DFACE);
	syscolor.ButtonHilight			= GetSysColor(COLOR_3DHILIGHT);
	syscolor.ButtonLight			= GetSysColor(COLOR_3DLIGHT);
	syscolor.ButtonShadow			= GetSysColor(COLOR_3DSHADOW);
	syscolor.ButtonText				= GetSysColor(COLOR_BTNTEXT);
	syscolor.GradientActiveTitle	= GetSysColor(COLOR_GRADIENTACTIVECAPTION);
	syscolor.GradientInactiveTitle	= GetSysColor(COLOR_GRADIENTINACTIVECAPTION);
	syscolor.GrayText				= GetSysColor(COLOR_GRAYTEXT);
	syscolor.Hilight				= GetSysColor(COLOR_HIGHLIGHT);
	syscolor.HilightText			= GetSysColor(COLOR_HIGHLIGHTTEXT);
	syscolor.HotTrackingColor		= GetSysColor(COLOR_HOTLIGHT);
	syscolor.InactiveBorder			= GetSysColor(COLOR_INACTIVEBORDER);
	syscolor.InactiveTitle			= GetSysColor(COLOR_INACTIVECAPTION);
	syscolor.InactiveTitleText		= GetSysColor(COLOR_INACTIVECAPTIONTEXT);
	syscolor.InfoText				= GetSysColor(COLOR_INFOTEXT);
	syscolor.InfoWindow				= GetSysColor(COLOR_INFOBK);
	syscolor.Menu					= GetSysColor(COLOR_MENU);
	//syscolor.MenuBar				= GetSysColor(0/*COLOR_MENUBAR*/);
	//syscolor.MenuHilight			= GetSysColor(0/*COLOR_MENUHIGHLIGHT*/);
	syscolor.MenuText				= GetSysColor(COLOR_MENUTEXT);
	syscolor.Scrollbar				= GetSysColor(COLOR_SCROLLBAR);
	syscolor.TitleText				= GetSysColor(COLOR_CAPTIONTEXT);
	syscolor.Window					= GetSysColor(COLOR_WINDOW);
	syscolor.WindowFrame			= GetSysColor(COLOR_WINDOWFRAME);
	syscolor.WindowText				= GetSysColor(COLOR_WINDOWTEXT);

	return;
}

void SaveCurrentColor(void)
{
	SetSysColors(sizeof(colorids) / sizeof(int), colorids, (COLORREF*)&syscolor);

	return;
}

char* ReadLine(HANDLE hf)
{
	DWORD bsize = 256;
	DWORD i = 0;
	char* s;
	DWORD read;

	if(!(s = halloc(bsize)))
		return NULL;

	for(;;)
	{
		if(!ReadFile(hf, s + i, 1, &read, NULL))
		{
			hfree(s);
			return NULL;
		}
		if(read != 1)
		{
			hfree(s);
			return NULL;
		}
		if(s[i] == 0x0D)
		{
			SetFilePointer(hf, +1, NULL, FILE_CURRENT);
			break;
		}
		i += read;
		if(i >= bsize)
		{
			bsize += 256;
			if(!(s = hrealloc(s, bsize)))
				return NULL;
		}
	}

	s[i] = '\0';

	return s;
}

void Load3DC(char* fname)
{
	HANDLE hf;
	char* s;
	DWORD i;

	if((hf = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
	{
		MessageBox(NULL, "Can't open file", "Error", MB_ICONERROR | MB_OK);
		return;
	}

	for(i = 0; s = ReadLine(hf); i++)
	{
		((COLORREF*)&syscolor)[cc2scTable[i]] = strToDword(s);
		hfree(s);
	}

	CloseHandle(hf);

	return;
}

BOOL CALLBACK Dialog3DLProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_DESTROY:
		while(SendMessage(GetDlgItem(hWnd, IDC_LIST), LB_GETCOUNT, 0, 0))
		{
			hfree((void*)SendMessage(GetDlgItem(hWnd, IDC_LIST), LB_GETITEMDATA, 0, 0));
			SendMessage(GetDlgItem(hWnd, IDC_LIST), LB_DELETESTRING, 0, 0);
		}
		break;
	case WM_CLOSE:
		DestroyWindow(hWnd);
		break;
	case WM_COMMAND:
		if(HIWORD(wParam) == LBN_SELCHANGE)
		{
			char* scheme = (char*)SendMessage(GetDlgItem(hWnd, IDC_LIST), LB_GETITEMDATA, SendMessage(GetDlgItem(hWnd, IDC_LIST), LB_GETCURSEL, 0, 0), 0);
			char* c;
			DWORD i;

			skipToken(&scheme, '"');
			skipToken(&scheme, '"');

			for(i = 0; c = getToken(&scheme, '|'); i++)
			{
				((COLORREF*)&syscolor)[cc2scTable[i]] = strToDword(c);
				hfree(c);
			}

			InvalidateRect(hMainWnd, NULL, FALSE);
		}else
			if(LOWORD(wParam) == IDOK)
				SendMessage(hWnd, WM_CLOSE, 0, 0);
		break;
	}
	return FALSE;
}

void Load3DL(char* fname)
{
	HANDLE hf;
	char* s;
	DWORD i;
	HWND hw;

	if((hf = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
	{
		MessageBox(NULL, "Can't open file", "Error", MB_ICONERROR | MB_OK);
		return;
	}

	hw = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_3DLDIALOG), hMainWnd, Dialog3DLProc);

	for(i = 0; s = ReadLine(hf); i++)
	{
		char* b = s;
		char* n;

		n = getToken(&b, '"');
		//hfree(s);

		SendMessage(GetDlgItem(hw, IDC_LIST), LB_INSERTSTRING, i, (LPARAM)n);
		SendMessage(GetDlgItem(hw, IDC_LIST), LB_SETITEMDATA, i, (LPARAM)s);

		hfree(n);
	}

	ShowWindow(hw, SW_SHOW);

	CloseHandle(hf);

	return;
}

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static BOOL movingflag = FALSE;
	static POINT shift;
	static DWORD movingitem;
	static POINT rb;

	switch(msg)
	{
	case WM_CREATE:
		SendMessage(hWnd, WM_COMMAND, 3, 0);	//LoadCurrent
		break;
	case WM_SYSCOLORCHANGE:
		LoadCurrentColor();
		break;
	case WM_CLOSE:
		PostQuitMessage(0);
		return 0;
	case WM_PAINT:
		{
			HDC hdc;
			PAINTSTRUCT ps;

			RECT rc;
			SIZE csize;
#ifdef DOUBLEBUFFER
			HDC backbuffer;
			HBITMAP obmp;
			BITMAPINFO bi;
#endif

			GetClientRect(hWnd, &rc);
			csize.cx = rc.right;
			csize.cy = rc.bottom;
			InvalidateRect(hWnd, NULL, TRUE);

			hdc = BeginPaint(hWnd, &ps);

#ifdef DOUBLEBUFFER
			backbuffer = CreateCompatibleDC(hdc);
			ZeroMemory(&bi, sizeof(bi));
			bi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
			bi.bmiHeader.biBitCount = 32;
			bi.bmiHeader.biPlanes = 1;
			bi.bmiHeader.biWidth = csize.cx;
			bi.bmiHeader.biHeight = csize.cy;
			obmp = SelectDIBSection(backbuffer, &bi, DIB_RGB_COLORS, NULL, NULL, 0);
#endif

#ifdef DOUBLEBUFFER
			{
				HBRUSH ob = SelectSolidBrush(backbuffer, syscolor.Background);
				FillRectangle(backbuffer, 0, 0, csize.cx, csize.cy);
				RestoreObject(backbuffer, ob);
			}
			{
				int i;

				for(i = 0; i < MAXWNDS; i++)
					drawWindow(backbuffer, &wnd[i]);
			}
#else
			{
				HBRUSH ob = SelectSolidBrush(hdc, syscolor.Background);
				FillRectangle(hdc, 0, 0, csize.cx, csize.cy);
				RestoreObject(hdc, ob);
			}
			{
				int i;

				for(i = 0; i < MAXWNDS; i++)
					drawWindow(hdc, &wnd[i]);
			}
#endif

#ifdef DOUBLEBUFFER
			BitBlt(hdc, 0, 0, csize.cx, csize.cy, backbuffer, 0, 0, SRCCOPY);

			RestoreObject(backbuffer, obmp);
#endif

			EndPaint(hWnd, &ps);
		}
		return 0;
	case WM_LBUTTONDBLCLK:
		{
			SID_IDENTIFIER_AUTHORITY sia = SECURITY_NT_AUTHORITY;
			PSID psid;
			SID_NAME_USE snu;
			char name[80];
			char domain[80];
			DWORD sname = sizeof(name);
			DWORD sdomain = sizeof(domain);

			//AllocateAndInitializeSid(&sia, 5, 21, 861567501, 842925246, 839522115, 1001, 0, 0, 0, &psid);
			AllocateAndInitializeSidx(&sia, 1, 18, 861567501, 842925246, 839522115, 1001, 0, 0, 0, &psid);
			LookupAccountSidAx(NULL, psid, name, &sname, domain, &sdomain, &snu);
			FreeSidx(psid);
			MessageBox(hWnd, name, domain, MB_OK);
		}
		break;
	case WM_LBUTTONDOWN:
		{
			POINT mp = {LOWORD(lParam), HIWORD(lParam)};
			WORD active;

			movingflag = TRUE;
			movingitem = hittest(&mp);
			active = HIWORD(movingitem);

			GetCapture();
			InvalidateRect(hWnd, NULL, TRUE);

			if(wnd[active].type == WINDOW_NORMAL)
			{
				if(LOBYTE(movingitem) == WNDHT_TOPLEFT)
				{
					shift.x = wnd[active].pos.x - mp.x;
					shift.y = wnd[active].pos.y - mp.y;
					rb.x = wnd[active].pos.x + wnd[active].size.cx;
					rb.y = wnd[active].pos.y + wnd[active].size.cy;
					break;
				}
				if(LOBYTE(movingitem) == WNDHT_TOP)
				{
					shift.y = wnd[active].pos.y - mp.y;
					rb.y = wnd[active].pos.y + wnd[active].size.cy;
					break;
				}
				if(LOBYTE(movingitem) == WNDHT_TOPRIGHT)
				{
					shift.x = wnd[active].pos.x + wnd[active].size.cx - mp.x;
					shift.y = wnd[active].pos.y - mp.y;
					rb.y = wnd[active].pos.y + wnd[active].size.cy;
					break;
				}
				if(LOBYTE(movingitem) == WNDHT_LEFT)
				{
					shift.x = wnd[active].pos.x - mp.x;
					rb.x = wnd[active].pos.x + wnd[active].size.cx;
					break;
				}
				if(LOBYTE(movingitem) == WNDHT_RIGHT)
				{
					shift.x = wnd[active].pos.x + wnd[active].size.cx - mp.x;
					break;
				}
				if(LOBYTE(movingitem) == WNDHT_BOTTOMLEFT)
				{
					shift.x = wnd[active].pos.x - mp.x;
					shift.y = wnd[active].pos.y + wnd[active].size.cy - mp.y;
					rb.x = wnd[active].pos.x + wnd[active].size.cx;
					break;
				}
				if(LOBYTE(movingitem) == WNDHT_BOTTOM)
				{
					shift.y = wnd[active].pos.y + wnd[active].size.cy - mp.y;
					break;
				}
				if(LOBYTE(movingitem) == WNDHT_BOTTOMRIGHT)
				{
					shift.x = wnd[active].pos.x + wnd[active].size.cx - mp.x;
					shift.y = wnd[active].pos.y + wnd[active].size.cy - mp.y;
					break;
				}
			}
			if(LOBYTE(movingitem) == WNDHT_TITLE)
			{
				shift.x = wnd[active].pos.x - mp.x;
				shift.y = wnd[active].pos.y - mp.y;
				break;
			}

			movingitem = 0;

			// init moving
			//SendMessage(hWnd, WM_MOUSEMOVE, wParam, lParam);
		}
		break;
	case WM_MOUSEMOVE:
		if(movingflag && movingitem)
		{
			POINT mp = {LOWORD(lParam), HIWORD(lParam)};
			WORD active = HIWORD(movingitem);

			switch(LOBYTE(movingitem))
			{
			case WNDHT_TOPLEFT:
				//wnd[active].size.cx += wnd[active].pos.x - mp.x - shift.x;
				//wnd[active].size.cy += wnd[active].pos.y - mp.y - shift.y;
				wnd[active].size.cx = rb.x - mp.x - shift.x;
				wnd[active].size.cy = rb.y - mp.y - shift.y;
				wnd[active].pos.x = mp.x + shift.x;
				wnd[active].pos.y = mp.y + shift.y;
				if(wnd[active].size.cx < MINWNDX)
					wnd[active].pos.x = rb.x - MINWNDX;
				if(wnd[active].size.cy < MINWNDY)
					wnd[active].pos.y = rb.y - MINWNDY;
				break;
			case WNDHT_TOP:
				wnd[active].size.cy = rb.y - mp.y - shift.y;
				wnd[active].pos.y = mp.y + shift.y;
				if(wnd[active].size.cy < MINWNDY)
					wnd[active].pos.y = rb.y - MINWNDY;
				break;
			case WNDHT_TOPRIGHT:
				wnd[active].size.cx = mp.x - wnd[active].pos.x + shift.x;
				wnd[active].size.cy = rb.y - mp.y - shift.y;
				wnd[active].pos.y = mp.y + shift.y;
				if(wnd[active].size.cy < MINWNDY)
					wnd[active].pos.y = rb.y - MINWNDY;
				break;
			case WNDHT_LEFT:
				wnd[active].size.cx = rb.x - mp.x - shift.x;
				wnd[active].pos.x = mp.x + shift.x;
				if(wnd[active].size.cx < MINWNDX)
					wnd[active].pos.x = rb.x - MINWNDX;
				break;
			case WNDHT_TITLE:
				wnd[active].pos.x = mp.x + shift.x;
				wnd[active].pos.y = mp.y + shift.y;
				break;
			case WNDHT_RIGHT:
				wnd[active].size.cx = mp.x - wnd[active].pos.x + shift.x;
				break;
			case WNDHT_BOTTOMLEFT:
				wnd[active].size.cx = rb.x - mp.x - shift.x;
				wnd[active].pos.x = mp.x + shift.x;
				wnd[active].size.cy = mp.y - wnd[active].pos.y + shift.y;
				if(wnd[active].size.cx < MINWNDX)
					wnd[active].pos.x = rb.x - MINWNDX;
				break;
			case WNDHT_BOTTOM:
				wnd[active].size.cy = mp.y - wnd[active].pos.y + shift.y;
				break;
			case WNDHT_BOTTOMRIGHT:
				wnd[active].size.cx = mp.x - wnd[active].pos.x + shift.x;
				wnd[active].size.cy = mp.y - wnd[active].pos.y + shift.y;
				break;
			}
			if(wnd[active].type == WINDOW_NORMAL || wnd[active].type == WINDOW_DIALOG)
			{
				if(wnd[active].size.cx < MINWNDX)
					wnd[active].size.cx = MINWNDX;
				if(wnd[active].size.cy < MINWNDY)
					wnd[active].size.cy = MINWNDY;
			}

			InvalidateRect(hWnd, NULL, TRUE);
		}
 
		// SetMouseCursor
		{
			POINT mp = {LOWORD(lParam), HIWORD(lParam)};
			DWORD hit;

			if(movingflag)
				hit = movingitem;
			else
				hit = hittest(&mp);

			if(wnd[HIWORD(hit)].type == WINDOW_NORMAL)
			{
				if(LOBYTE(hit) == WNDHT_TOPLEFT || LOBYTE(hit) == WNDHT_BOTTOMRIGHT)
				{
					SetCursor(LoadCursor(NULL, IDC_SIZENWSE));
					break;
				}
				if(LOBYTE(hit) == WNDHT_TOP || LOBYTE(hit) == WNDHT_BOTTOM)
				{
					SetCursor(LoadCursor(NULL, IDC_SIZENS));
					break;
				}
				if(LOBYTE(hit) == WNDHT_TOPRIGHT || LOBYTE(hit) == WNDHT_BOTTOMLEFT)
				{
					SetCursor(LoadCursor(NULL, IDC_SIZENESW));
					break;
				}
				if(LOBYTE(hit) == WNDHT_LEFT || LOBYTE(hit) == WNDHT_RIGHT)
				{
					SetCursor(LoadCursor(NULL, IDC_SIZEWE));
					break;
				}
			}
			if(LOBYTE(hit) == WNDHT_TITLE)
			{
				SetCursor(LoadCursor(NULL, IDC_SIZEALL));
				break;
			}

			SetCursor(LoadCursor(NULL, IDC_ARROW));
		}
		break;
	case WM_LBUTTONUP:
		movingflag = FALSE;
		ReleaseCapture();
		break;
	case WM_CONTEXTMENU:
		{
			HMENU hm;
			MENUITEMINFO mii;
			POINT mp;// = {LOWORD(lParam), HIWORD(lParam)};
			DWORD ht;

			GetCursorPos(&mp);	// VK_APPS,<S-F10>ŉEɏôh~
			ScreenToClient(hWnd, &mp);
			ht = hittest(&mp);
			ClientToScreen(hWnd, &mp);

			hm = CreatePopupMenu();
			ZeroMemory(&mii, sizeof(mii));
			mii.cbSize = sizeof(mii);
			mii.fMask = MIIM_TYPE | MIIM_ID | MIIM_DATA | MIIM_STATE;
			mii.fType = MFT_STRING;

			{
				char str[80];

				mii.fState = MFS_DISABLED;
				if(LOBYTE(ht) == WNDHT_NONE)
					strcopy(str, "Desktop");
				else
					switch(wnd[HIWORD(ht)].type)
					{
					case WINDOW_NORMAL:
						strcopy(str, "Window ");
						strplus(str, htstring[LOBYTE(ht)]);
						break;
					case WINDOW_DIALOG:
						strcopy(str, "Dialog ");
						strplus(str, htstring[LOBYTE(ht)]);
						break;
					case WINDOW_TOOLTIP:
						strcopy(str, "Tooltip");
						break;
					case WINDOW_POPUPMENU:
						strcopy(str, "PopupMenu ");
						strplus(str, htstring[HIBYTE(ht)]);
						break;
					}
				mii.dwTypeData = str;
				InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			}
			mii.fType = MFT_SEPARATOR;
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.fType = MFT_STRING;
			mii.fState = 0;

			switch(wnd[HIWORD(ht)].type)
			{
			case WINDOW_NORMAL:
			case WINDOW_DIALOG:
			case WINDOW_POPUPMENU:
				if(	LOBYTE(ht) == WNDHT_TOPLEFT ||
					LOBYTE(ht) == WNDHT_TOP ||
					LOBYTE(ht) == WNDHT_LEFT ||
					LOBYTE(ht) == WNDHT_TOPRIGHT ||
					LOBYTE(ht) == WNDHT_BOTTOMLEFT ||
					LOBYTE(ht) == WNDHT_BTNMINIMIZE ||
					LOBYTE(ht) == WNDHT_BTNMAXIMIZE ||
					LOBYTE(ht) == WNDHT_BTNCLOSE ||
					//(LOBYTE(ht) == WNDHT_BTNMAXIMIZE && wnd[HIWORD(ht)].style & WINDOW_NOMAXIMIZE) ||
					LOBYTE(ht) == WNDHT_MENUDISABLE ||
						(wnd[HIWORD(ht)].type == WINDOW_POPUPMENU && (
							HIBYTE(ht) == WNDHT_MENUDISABLE ||
							HIBYTE(ht) == WNDHT_MENUSEPARATOR
						))
					)
				{
					mii.wID = ID_COLORCMDBASE + ButtonHilight;
					mii.dwTypeData = "3D Hilight";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}
				if(	LOBYTE(ht) == WNDHT_TOPLEFT ||
					LOBYTE(ht) == WNDHT_TOP ||
					LOBYTE(ht) == WNDHT_LEFT ||
					LOBYTE(ht) == WNDHT_TOPRIGHT ||
					LOBYTE(ht) == WNDHT_BOTTOMLEFT ||
					LOBYTE(ht) == WNDHT_BTNMINIMIZE ||
					LOBYTE(ht) == WNDHT_BTNMAXIMIZE ||
					LOBYTE(ht) == WNDHT_BTNCLOSE
					)
				{
					mii.wID = ID_COLORCMDBASE + ButtonLight;
					mii.dwTypeData = "3D Light";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}
				if(	LOBYTE(ht) == WNDHT_TOPRIGHT ||
					LOBYTE(ht) == WNDHT_BOTTOMLEFT ||
					LOBYTE(ht) == WNDHT_BOTTOMRIGHT ||
					LOBYTE(ht) == WNDHT_BOTTOM ||
					LOBYTE(ht) == WNDHT_RIGHT ||
					LOBYTE(ht) == WNDHT_BTNMINIMIZE ||
					LOBYTE(ht) == WNDHT_BTNMAXIMIZE ||
					LOBYTE(ht) == WNDHT_BTNCLOSE ||
					//(LOBYTE(ht) == WNDHT_BTNMAXIMIZE && wnd[HIWORD(ht)].style & WINDOW_NOMAXIMIZE)
					LOBYTE(ht) == WNDHT_MENUDISABLE ||
					LOBYTE(ht) == WNDHT_MENUINACTIVE ||
						(wnd[HIWORD(ht)].type == WINDOW_POPUPMENU && (
							HIBYTE(ht) == WNDHT_MENUDISABLE ||
							HIBYTE(ht) == WNDHT_MENUSEPARATOR
						))
					)
				{
					mii.wID = ID_COLORCMDBASE + ButtonShadow;
					mii.dwTypeData = "3D Shadow";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}
				if(	LOBYTE(ht) == WNDHT_TOPRIGHT ||
					LOBYTE(ht) == WNDHT_BOTTOMLEFT ||
					LOBYTE(ht) == WNDHT_BOTTOMRIGHT ||
					LOBYTE(ht) == WNDHT_BOTTOM ||
					LOBYTE(ht) == WNDHT_RIGHT ||
					LOBYTE(ht) == WNDHT_BTNMINIMIZE ||
					LOBYTE(ht) == WNDHT_BTNMAXIMIZE ||
					LOBYTE(ht) == WNDHT_BTNCLOSE
					)
				{
					mii.wID = ID_COLORCMDBASE + ButtonDkShadow;
					mii.dwTypeData = "3D DarkShadow";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}

				if(	(wnd[HIWORD(ht)].type == WINDOW_DIALOG && LOBYTE(ht) == WNDHT_CLIENT) ||
					LOBYTE(ht) == WNDHT_BTNMINIMIZE ||
					LOBYTE(ht) == WNDHT_BTNMAXIMIZE ||
					LOBYTE(ht) == WNDHT_BTNCLOSE
					)
				{
					mii.wID = ID_COLORCMDBASE + ButtonFace;
					mii.dwTypeData = "3D Face";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}

				if(LOBYTE(ht) == WNDHT_CLIENT && wnd[HIWORD(ht)].type == WINDOW_NORMAL && !(wnd[HIWORD(ht)].style & WINDOW_ACTIVE))
				{
					mii.wID = ID_COLORCMDBASE + AppWorkSpace;
					mii.dwTypeData = "AppWorkSpace";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}
				if(LOBYTE(ht) == WNDHT_CLIENT && wnd[HIWORD(ht)].type == WINDOW_NORMAL && wnd[HIWORD(ht)].style & WINDOW_ACTIVE)
				{
					mii.wID = ID_COLORCMDBASE + Window;
					mii.dwTypeData = "WindowBkgnd";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}
				if(LOBYTE(ht) == WNDHT_CLIENT && wnd[HIWORD(ht)].type == WINDOW_DIALOG)
				{
					mii.wID = ID_COLORCMDBASE + WindowFrame;
					mii.dwTypeData = "WindowFrame";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}

				if(LOBYTE(ht) == WNDHT_CLIENT && ((wnd[HIWORD(ht)].type == WINDOW_NORMAL && wnd[HIWORD(ht)].style & WINDOW_ACTIVE) || wnd[HIWORD(ht)].type == WINDOW_DIALOG))
				{
					mii.wID = ID_COLORCMDBASE + WindowText;
					mii.dwTypeData = "WindowText";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}

				if(LOBYTE(ht) == WNDHT_CLIENT && wnd[HIWORD(ht)].type == WINDOW_NORMAL && wnd[HIWORD(ht)].style & WINDOW_ACTIVE)
				{
					mii.wID = ID_COLORCMDBASE + Scrollbar;
					mii.dwTypeData = "ScrollBar";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}

				if(	wnd[HIWORD(ht)].type == WINDOW_NORMAL && (
					LOBYTE(ht) == WNDHT_TOPLEFT ||
					LOBYTE(ht) == WNDHT_TOP ||
					LOBYTE(ht) == WNDHT_TOPRIGHT ||
					LOBYTE(ht) == WNDHT_LEFT ||
					LOBYTE(ht) == WNDHT_RIGHT ||
					LOBYTE(ht) == WNDHT_BOTTOMLEFT ||
					LOBYTE(ht) == WNDHT_BOTTOM ||
					LOBYTE(ht) == WNDHT_BOTTOMRIGHT
					))
				{
					if(wnd[HIWORD(ht)].style & WINDOW_ACTIVE)
					{
						mii.wID = ID_COLORCMDBASE + ActiveBorder;
						mii.dwTypeData = "Active Border";
						InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
					}else
					{
						mii.wID = ID_COLORCMDBASE + InactiveBorder;
						mii.dwTypeData = "Inactive Border";
						InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
					}
				}

				if(LOBYTE(ht) == WNDHT_TITLE && wnd[HIWORD(ht)].type != WINDOW_POPUPMENU)
					if(wnd[HIWORD(ht)].style & WINDOW_ACTIVE)
					{
						mii.wID = ID_COLORCMDBASE + ActiveTitle;
						mii.dwTypeData = "Active Title";
						InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
						mii.wID = ID_COLORCMDBASE + GradientActiveTitle;
						mii.dwTypeData = "Gradient Active Title";
						InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
						mii.wID = ID_COLORCMDBASE + TitleText;
						mii.dwTypeData = "Active Title Text";
						InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
					}else
					{
						mii.wID = ID_COLORCMDBASE + InactiveTitle;
						mii.dwTypeData = "Inactive Title";
						InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
						mii.wID = ID_COLORCMDBASE + GradientInactiveTitle;
						mii.dwTypeData = "Gradient Inactive Title";
						InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
						mii.wID = ID_COLORCMDBASE + InactiveTitleText;
						mii.dwTypeData = "Inactive Title Text";
						InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
					}

				if(	LOBYTE(ht) == WNDHT_BTNMINIMIZE ||
					(LOBYTE(ht) == WNDHT_BTNMAXIMIZE && !(wnd[HIWORD(ht)].style & WINDOW_NOMAXIMIZE)) ||
					LOBYTE(ht) == WNDHT_BTNCLOSE
					)
				{
					mii.wID = ID_COLORCMDBASE + ButtonText;
					mii.dwTypeData = "Button text";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}

				if(	LOBYTE(ht) == WNDHT_MENU ||
					LOBYTE(ht) == WNDHT_MENUDISABLE ||
					LOBYTE(ht) == WNDHT_MENUINACTIVE ||
						(wnd[HIWORD(ht)].type == WINDOW_POPUPMENU && (
							HIBYTE(ht) == WNDHT_MENU ||
							HIBYTE(ht) == WNDHT_MENUDISABLE ||
							HIBYTE(ht) == WNDHT_MENUSEPARATOR
						))
					)
				{
					mii.wID = ID_COLORCMDBASE + Menu;
					mii.dwTypeData = "Menu Background";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}
				if(	LOBYTE(ht) == WNDHT_MENU ||
					(wnd[HIWORD(ht)].type == WINDOW_POPUPMENU && HIBYTE(ht) == WNDHT_MENU)
					)
				{
					mii.wID = ID_COLORCMDBASE + MenuText;
					mii.dwTypeData = "Menu Text";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}

				if(	LOBYTE(ht) == WNDHT_MENUHILIGHT ||
					(wnd[HIWORD(ht)].type == WINDOW_POPUPMENU && HIBYTE(ht) == WNDHT_MENUHILIGHT)
					)
				{
					mii.wID = ID_COLORCMDBASE + Hilight;
					mii.dwTypeData = "Highlight";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}
				if(	LOBYTE(ht) == WNDHT_MENUHILIGHT ||
					(wnd[HIWORD(ht)].type == WINDOW_POPUPMENU && HIBYTE(ht) == WNDHT_MENUHILIGHT)
					)
				{
					mii.wID = ID_COLORCMDBASE + HilightText;
					mii.dwTypeData = "Highlight Text";
					InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				}

				break;
			case WINDOW_TOOLTIP:
				mii.wID = ID_COLORCMDBASE + WindowFrame;
				mii.dwTypeData = "WindowFrame";
				InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				mii.wID = ID_COLORCMDBASE + InfoWindow;
				mii.dwTypeData = "Tooptip Background";
				InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				mii.wID = ID_COLORCMDBASE + InfoText;
				mii.dwTypeData = "Tooptip Text";
				InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
				break;
			}
			if(LOBYTE(ht) == WNDHT_NONE)
			{
				mii.wID = ID_COLORCMDBASE + Background;
				mii.dwTypeData = "Desktop";
				InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			}

			mii.fType = MFT_SEPARATOR;
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.fType = MFT_STRING;
			mii.wID = ID_SAVECURRENT;
			mii.dwTypeData = "SetCurrent";
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.fType = MFT_STRING;
			mii.wID = ID_SAVECURREG;
			mii.dwTypeData = "SetCurrent+registry";
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);

			mii.fType = MFT_STRING;
			mii.wID = ID_LOADCURRENT;
			mii.dwTypeData = "LoadCurrent";
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.fType = MFT_STRING;
			mii.wID = ID_LOADREG;
			mii.dwTypeData = "LoadRegistry";
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);

			mii.fType = MFT_SEPARATOR;
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.fType = MFT_STRING;

			mii.wID = ID_SAVEDEFAULT;
			mii.dwTypeData = "Set.DEFAULT";
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.wID = ID_LOADDEFAULT;
			mii.dwTypeData = "Load.DEFAULT";
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);

			mii.fType = MFT_SEPARATOR;
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.fType = MFT_STRING;

			mii.wID = ID_LOAD3DC;
			mii.dwTypeData = "Load 3DCC Theme";
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.wID = ID_LOAD3DL;
			mii.dwTypeData = "Open 3DCC Library";
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);

			TrackPopupMenu(hm, 0, mp.x, mp.y, 0, hWnd, NULL);
			DestroyMenu(hm);
		}
		break;
	case WM_COMMAND:
		if(LOWORD(wParam) == ID_SAVECURRENT || LOWORD(wParam) == ID_SAVECURREG)
			SaveCurrentColor();
		if(LOWORD(wParam) == ID_SAVECURREG)
			SaveColor("HKEY_CURRENT_USER\\Control Panel\\Colors");
		if(LOWORD(wParam) == ID_LOADCURRENT)
			LoadCurrentColor();
		if(LOWORD(wParam) == ID_LOADREG)
			LoadColor("HKEY_CURRENT_USER\\Control Panel\\Colors");
		if(LOWORD(wParam) == ID_SAVEDEFAULT)
			SaveColor("HKEY_USERS\\.DEFAULT\\Control Panel\\Colors");
		if(LOWORD(wParam) == ID_LOADDEFAULT)
			LoadColor("HKEY_USERS\\.DEFAULT\\Control Panel\\Colors");
		if(LOWORD(wParam) == ID_LOAD3DC)
		{
			OPENFILENAME ofn = {0};
			char fn[MAX_PATH];

			ofn.lStructSize = sizeof(ofn);
			ofn.hInstance = GetModuleHandle(NULL);
			ofn.hwndOwner = hWnd;
			fn[0] = '\0';
			ofn.lpstrFile = fn;
			ofn.lpstrTitle = "Open 3DCC ColorScheme";
			ofn.lpstrFilter = "3DCC ColorScheme(*.3dc)\0*.3dc\0";
			ofn.nMaxFile = MAX_PATH;
			ofn.Flags = OFN_FILEMUSTEXIST;

			if(GetOpenFileName(&ofn))
				Load3DC(fn);
		}
		if(LOWORD(wParam) == ID_LOAD3DL)
		{
			OPENFILENAME ofn = {0};
			char fn[MAX_PATH];

			ofn.lStructSize = sizeof(ofn);
			ofn.hInstance = GetModuleHandle(NULL);
			ofn.hwndOwner = hWnd;
			fn[0] = '\0';
			ofn.lpstrFile = fn;
			ofn.lpstrTitle = "Open 3DCC ColorScheme";
			ofn.lpstrFilter = "3DCC ColorLibrary(*.3dl)\0*.3dl\0";
			ofn.nMaxFile = MAX_PATH;
			ofn.Flags = OFN_FILEMUSTEXIST;

			if(GetOpenFileName(&ofn))
				Load3DL(fn);
		}

		if(ID_COLORCMDBASE <= LOWORD(wParam) && LOWORD(wParam) < ID_COLORCMDBASE + 50)
		{
			CHOOSECOLOR cc = {0};
			COLORREF cr[16] = {0};

			cc.lStructSize = sizeof(cc);
			cc.hwndOwner = hWnd;
			cc.rgbResult = ((COLORREF*)&syscolor)[LOWORD(wParam) - ID_COLORCMDBASE];
			cc.Flags = CC_RGBINIT | CC_FULLOPEN;
			cc.lpCustColors = cr;
			if(ChooseColor(&cc))
				((COLORREF*)&syscolor)[LOWORD(wParam) - ID_COLORCMDBASE] = cc.rgbResult;
		}

		InvalidateRect(hWnd, NULL, FALSE);

		break;
	case WM_MBUTTONDOWN:
		{
			HMENU hm = CreatePopupMenu();
			MENUITEMINFO mii = {0};
			POINT mp = {LOWORD(lParam), HIWORD(lParam)};

			mii.cbSize = sizeof(mii);
			mii.fMask = MIIM_TYPE | MIIM_ID | MIIM_DATA | MIIM_STATE;
			mii.fType = MFT_STRING;

			mii.dwTypeData = "WheelMode";
			mii.fState = MFS_DISABLED;
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.fType = MFT_SEPARATOR;
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.fType = MFT_STRING;

			mii.wID = ID_CMNOAFFECT;
			mii.dwTypeData = "(None)";
			if(currentmode == CM_NOAFFECT)
				mii.fState = MFS_CHECKED | MFS_DEFAULT;
			else
				mii.fState = 0;
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.wID = ID_CMBORDER;
			mii.dwTypeData = "Border";
			if(currentmode == CM_BORDER)
				mii.fState = MFS_CHECKED | MFS_DEFAULT;
			else
				mii.fState = 0;
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.wID = ID_CMTITLE;
			mii.dwTypeData = "Title";
			if(currentmode == CM_TITLE)
				mii.fState = MFS_CHECKED | MFS_DEFAULT;
			else
				mii.fState = 0;
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.wID = ID_CMMENU;
			mii.dwTypeData = "Menu";
			if(currentmode == CM_MENU)
				mii.fState = MFS_CHECKED | MFS_DEFAULT;
			else
				mii.fState = 0;
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);
			mii.wID = ID_CMSCROLLBAR;
			mii.dwTypeData = "Scrollbar";
			if(currentmode == CM_SCROLLBAR)
				mii.fState = MFS_CHECKED | MFS_DEFAULT;
			else
				mii.fState = 0;
			InsertMenuItem(hm, GetMenuItemCount(hm), TRUE, &mii);

			ClientToScreen(hWnd, &mp);
			switch(TrackPopupMenu(hm, TPM_RETURNCMD, mp.x, mp.y, 0, hWnd, NULL))
			{
			case ID_CMBORDER:
				currentmode = CM_BORDER;
				break;
			case ID_CMTITLE:
				currentmode = CM_TITLE;
				break;
			case ID_CMMENU:
				currentmode = CM_MENU;
				break;
			case ID_CMSCROLLBAR:
				currentmode = CM_SCROLLBAR;
				break;
			case ID_CMNOAFFECT:
				currentmode = CM_NOAFFECT;
				break;
			}

			DestroyMenu(hm);
		}
		break;
	case WM_MOUSEWHEEL:
		/*
		if((short)HIWORD(wParam) < 0)
			titlesize--;
		if((short)HIWORD(wParam) > 0)
			titlesize++;
		*/
		switch(currentmode)
		{
		case CM_BORDER:
			bordersize += (short)HIWORD(wParam) / 120;
			break;
		case CM_TITLE:
			titlesize += (short)HIWORD(wParam) / 120;
			break;
		case CM_MENU:
			menusize += (short)HIWORD(wParam) / 120;
			break;
		case CM_SCROLLBAR:
			scrollbarsize += (short)HIWORD(wParam) / 120;
			break;
		}
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	}
	return DefWindowProc(hWnd, msg, wParam, lParam);
}

int initapp(void)
{
	WNDCLASSEX wc;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize = sizeof(wc);
	wc.lpfnWndProc = MainWndProc;
	wc.hInstance = GetModuleHandle(NULL);
	wc.hIcon = LoadIcon(wc.hInstance, MAKEINTRESOURCE(IDI_MAINICON));
	//wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	//wc.hbrBackground = (HBRUSH)(COLOR_DESKTOP + 1);
	wc.lpszClassName = "ColorsetWndClass";
	wc.style = CS_DBLCLKS;

	if(!(RegisterClassEx(&wc)))
		return 1;

	{
		RECT rc = {0, 0, 480, 360};

		AdjustWindowRect(&rc, WS_SYSMENU | WS_MINIMIZEBOX, FALSE);
		if(!(hMainWnd = CreateWindowEx(0, wc.lpszClassName, "Colorset", WS_SYSMENU | WS_MINIMIZEBOX,
			CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top,
			NULL, NULL, wc.hInstance, NULL)))
			return 1;
	}

	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nShowCmd)
{
	MSG msg;

	if(initapp())
		ExitProcess(1);

	{
		HMODULE hDll;
		hDll = LoadLibrary("advapi32.dll");

		if(!((FARPROC)LookupAccountSidAx = GetProcAddress(hDll, "LookupAccountSidA")))
			MessageBox(NULL, "LookupAccountSidA擾s", "warn", MB_OK);
		if(!((FARPROC)AllocateAndInitializeSidx = GetProcAddress(hDll, "AllocateAndInitializeSid")))
			MessageBox(NULL, "AllocateAndInitializeSidA擾s", "warn", MB_OK);
		if(!((FARPROC)FreeSidx = GetProcAddress(hDll, "FreeSid")))
			MessageBox(NULL, "FreeSidA擾s", "warn", MB_OK);

		FreeLibrary(hDll);
	}
	ShowWindow(hMainWnd, SW_SHOW);

	while(GetMessage(&msg, NULL, 0, 0))
	{
		// translate iranaiyone?
		DispatchMessage(&msg);
	}

	ExitProcess(msg.wParam);
}
