#include "myrt.h"

// NT ONLY
BOOL (WINAPI *LookupAccountSidAx)(
    LPCSTR lpSystemName,
    PSID Sid,
    LPSTR Name,
    LPDWORD cbName,
    LPSTR ReferencedDomainName,
    LPDWORD cbReferencedDomainName,
    PSID_NAME_USE peUse
    ) = NULL;
BOOL (WINAPI *AllocateAndInitializeSidx)(
    PSID_IDENTIFIER_AUTHORITY pIdentifierAuthority,
    BYTE nSubAuthorityCount,
    DWORD nSubAuthority0,
    DWORD nSubAuthority1,
    DWORD nSubAuthority2,
    DWORD nSubAuthority3,
    DWORD nSubAuthority4,
    DWORD nSubAuthority5,
    DWORD nSubAuthority6,
    DWORD nSubAuthority7,
    PSID *pSid
    ) = NULL;
PVOID (WINAPI *FreeSidx)(
    PSID pSid
    ) = NULL;

typedef struct
{
	POINT pos;
	SIZE size;
	char title[80];
	DWORD type;	// Window, Tooltip, ...
	DWORD style;
	char menu[80];
}WINDOW;
enum
{
	WINDOW_NORMAL = 0,
	WINDOW_DIALOG,
	WINDOW_TOOLTIP,
	WINDOW_POPUPMENU,
};
#define WINDOW_NOMAXIMIZE	0x80000000
#define WINDOW_ACTIVE		0x40000000
#define WINDOW_MENU			0x20000000

#define MAXWNDS 5
WINDOW wnd[MAXWNDS] = 
{
	{
		10, 10,
		180, 85,
		"Inactive",
		WINDOW_NORMAL,
		WINDOW_NOMAXIMIZE | WINDOW_MENU,
		"File\0Edit\0Help\0"
	},
	{
		10, 100,
		180, 85,
		"Active",
		WINDOW_NORMAL,
		WINDOW_ACTIVE | WINDOW_MENU,
		"Game\0Multi\0Config\0Mod\0"
	},
	{
		200, 10,
		180, 85,
		"Dialog",
		WINDOW_DIALOG,
		0,
		""
	},
	{
		200, 100,
		150, 0,
		"",
		WINDOW_POPUPMENU,
		0,
		"Arrange\0Refresh\0-\0Paste\0-\0Property\0"
	},
	{
		275, 25,
		100, 20,
		"ToolTip",
		WINDOW_TOOLTIP,
		0,
		""
	},
};

struct
{
	COLORREF ActiveBorder;
	COLORREF ActiveTitle;
	COLORREF AppWorkSpace;
	COLORREF Background;
	COLORREF ButtonDkShadow;
	COLORREF ButtonFace;
	COLORREF ButtonHilight;
	COLORREF ButtonLight;
	COLORREF ButtonShadow;
	COLORREF ButtonText;
	COLORREF GrayText;
	COLORREF Hilight;
	COLORREF HilightText;
	COLORREF InactiveBorder;
	COLORREF InactiveTitle;
	COLORREF InactiveTitleText;
	COLORREF InfoText;
	COLORREF InfoWindow;
	COLORREF Menu;
	COLORREF MenuText;
	COLORREF Scrollbar;
	COLORREF TitleText;
	COLORREF Window;
	COLORREF WindowFrame;
	COLORREF WindowText;
	COLORREF GradientActiveTitle;
	COLORREF GradientInactiveTitle;
	COLORREF HotTrackingColor;
	COLORREF MenuBar;
	COLORREF MenuHilight;
	COLORREF ButtonAlternateFace;
}syscolor;
enum
{
	ActiveBorder = 0,
	ActiveTitle,
	AppWorkSpace,
	Background,
	ButtonDkShadow,
	ButtonFace,
	ButtonHilight,
	ButtonLight,
	ButtonShadow,
	ButtonText,
	GrayText,
	Hilight,
	HilightText,
	InactiveBorder,
	InactiveTitle,
	InactiveTitleText,
	InfoText,
	InfoWindow,
	Menu,
	MenuText,
	Scrollbar,
	TitleText,
	Window,
	WindowFrame,
	WindowText,
	GradientActiveTitle,
	GradientInactiveTitle,
	HotTrackingColor,
	MenuBar,
	MenuHilight,
	ButtonAlternateFace,
};

enum
{
	WNDHT_NONE = 0,
	WNDHT_TOPLEFT,
	WNDHT_TOP,
	WNDHT_TOPRIGHT,
	WNDHT_LEFT,
	WNDHT_RIGHT,
	WNDHT_BOTTOMLEFT,
	WNDHT_BOTTOM,
	WNDHT_BOTTOMRIGHT,

	WNDHT_TITLE,
	WNDHT_MENU,
	WNDHT_MENUHILIGHT,
	WNDHT_MENUDISABLE,
	WNDHT_MENUINACTIVE,
	WNDHT_CLIENT,

	WNDHT_BTNCLOSE,
	WNDHT_BTNMAXIMIZE,
	WNDHT_BTNMINIMIZE,

	WNDHT_MENUSEPARATOR,
};

char* htstring[] =
{
	"N/A",
	"Top-Left",
	"Top",
	"Top-Right",
	"Left",
	"Right",
	"Bottom-Left",
	"Bottom",
	"Bottom-Right",

	"Title",
	"Menu",
	"Menu-Highlight",
	"Menu-Disabled",
	"Menu-Inactive",
	"Client area",

	"Close button",
	"Maximize button",
	"Minimize button",

	"Menu-Separator",
};

int colorids[] =
{
	COLOR_ACTIVEBORDER,
	COLOR_ACTIVECAPTION,
	COLOR_APPWORKSPACE,
	COLOR_BACKGROUND,	// COLOR_DESKTOP
	COLOR_3DDKSHADOW,
	COLOR_3DFACE,
	COLOR_3DHILIGHT,
	COLOR_3DLIGHT,
	COLOR_3DSHADOW,
	COLOR_BTNTEXT,
	COLOR_GRAYTEXT,
	COLOR_HIGHLIGHT,
	COLOR_HIGHLIGHTTEXT,
	COLOR_INACTIVEBORDER,
	COLOR_INACTIVECAPTION,
	COLOR_INACTIVECAPTIONTEXT,
	COLOR_INFOTEXT,
	COLOR_INFOBK,
	COLOR_MENU,
	COLOR_MENUTEXT,
	COLOR_SCROLLBAR,
	COLOR_CAPTIONTEXT,
	COLOR_WINDOW,
	COLOR_WINDOWFRAME,
	COLOR_WINDOWTEXT,
	COLOR_GRADIENTACTIVECAPTION,
	COLOR_GRADIENTINACTIVECAPTION,
	COLOR_HOTLIGHT,
	/*
	0,//COLOR_MENUBAR,
	0,//COLOR_MENUHIGHLIGHT,
	0,//COLOR_ALTERNATE3DFACE,	//alternate...?
	*/
};

int cc2scTable[] =
{
	ButtonDkShadow,
	ButtonShadow,
	ButtonFace,
	ButtonAlternateFace,
	ButtonLight,
	ButtonHilight,
	ActiveTitle,
	GradientActiveTitle,
	TitleText,
	ActiveBorder,
	AppWorkSpace,
	ButtonText,
	Background,
	WindowFrame,
	GrayText,
	InactiveTitle,
	GradientInactiveTitle,
	InactiveTitleText,
	InactiveBorder,
	Menu,
	MenuText,
	Hilight,	// MouseHilight??
	Scrollbar,
	Hilight,
	HilightText,
	InfoWindow,
	InfoText,
	Window,
	WindowText,

	MenuHilight,
	MenuBar,
};

#define ID_SAVECURRENT	1
#define ID_SAVECURREG	2
#define ID_LOADCURRENT	3
#define ID_LOADREG		4
#define ID_SAVEDEFAULT	5
#define ID_LOADDEFAULT	6
#define ID_LOAD3DC		7
#define ID_LOAD3DL		8

#define ID_CMBORDER		50
#define ID_CMTITLE		51
#define ID_CMMENU		52
#define ID_CMSCROLLBAR	53
#define ID_CMNOAFFECT	54

#define ID_COLORCMDBASE	1000

#define MINWNDX 100
#define MINWNDY ((LONG)(4 + 2 + bordersize + titlesize + 3))
