#include "myrt.h"

void ZeroMemory(PVOID dst, DWORD size)
{
	while(size--)
		*((char*)dst)++ = 0;
}
DWORD strlength(LPCSTR str)
{
	DWORD c = 0;

	while(*str++)
		c++;

	return c;
}
char* strchar(const char* str, char tofind)
{
	char* p = (char*)str;

	while(*p)
	{
		if(!IsDBCSLeadByte(*p) && *p == tofind)
			break;
		p = CharNext(p);
	}

	return p;
}
VOID strncopy(LPSTR dst, LPCSTR src, DWORD size)
{
	while(*src && size--)
		*dst++ = *src++;

	return;
}
int strcomp(const char* p, const char *q)
{
	if(!p || !q)return 0;
	if(p == q)	return 0;

	for(; *p == *q && *p != '\0'; p++, q++);

	return *p - *q;
}
VOID strcopy(LPSTR dst, LPCSTR src)
{
	while(*src)	*dst++ = *src++;
	*dst = *src;

	return;
}
void strplus(char* p, const char *c)
{
	if(!p || !c || p == c)	return;

	p += strlength(p);
	strcopy(p, c);

	return;
}
void addEndYen(char* str)
{
	char* p = str;
	char* yen = str;

	while(*p)
	{
		if(!IsDBCSLeadByte(*p))
			if(*p == '\\')
				yen = p;
		p = CharNext(p);
	}

	if(yen != (str + strlength(str) - 1))
		strplus(str, "\\");

	return;
}
char* lastname(const char* str, char delimiter)
{
	char* last = (char*)str;

	while(*str)
	{
		if(!IsDBCSLeadByte(*str) && *str == delimiter)
			last = (char*)str + 1;
		str = CharNext(str);
	}

	return last;
}
char* basename(const char* str)
{
	return lastname(str, '\\');
}
void* halloc(DWORD size)
{
	return HeapAlloc(GetProcessHeap(), 0, size);
}
void* hrealloc(void* ptr, DWORD size)
{
	return HeapReAlloc(GetProcessHeap(), 0, ptr, size);
}
void hfree(void* ptr)
{
	if(ptr)	HeapFree(GetProcessHeap(), 0, ptr);

	return;
}
char* getToken(char** p, char tok)
{
	char* token;
	char* boost;
	DWORD len;

	if(!**p)	return 0;

	boost = *p;
	while(*boost && *boost != tok)	boost++;
	len = boost - *p;
	if(token = halloc(len + 1))
	{
		strncopy(token, *p, len);
		token[len] = '\0';
	}
	*p = boost;
	if(**p == tok)	(*p)++;

	return token;
}
DWORD strToDword(char* str)
{
	char* p;
	DWORD val = 0;

	for(p = str; '0' <= *p && *p <= '9'; p++)
	{
		val *= 10;
		val += *p - '0';
	}

	return val;
}
DWORD getTokenDword(char** str, char tok)
{
	char* token;
	DWORD val;

	token = getToken(str, tok);
	val = strToDword(token);
	hfree(token);

	return val;
}
void skipToken(char** p, char tok)
{
	char* boost;

	if(!**p)
		return;

	boost = *p;
	while(*boost && *boost != tok)	boost++;
	*p = boost;
	if(**p == tok)	(*p)++;

	return;
}
